#pragma once

#define VERTEX_TYPE Vertex_handle
#define HALFEDGE_TYPE Halfedge_handle
class Bridge
{
public:
	Bridge(VERTEX_TYPE oPolyVertexH1, VERTEX_TYPE oPolyVertexH2, HALFEDGE_TYPE convexHullHalfEdge);
	~Bridge(void);
	
	//add a pocket vertex to pocketVertices
	//NOTE: it is assumed AND REQUIRED that vertices will be added IN ORDER, going from oPolyVertexH2 --> oPolyVertexH1, along
	//the shortest path connecting the two vertices of the bridge
	void addPocketVertex(VERTEX_TYPE pocketVertex); 

	//Vertex of the original Polyhedron
	VERTEX_TYPE oPolyVertexH1;

	//Vertex of the original Polyhedron
	VERTEX_TYPE  oPolyVertexH2; 

	//Edge of the bridge (which is on the polygon of the convex hull)
	HALFEDGE_TYPE convexHullHalfEdge; 

	//list of vertices defining the pocket (the shortest path on the original polyhedron, connecting the two vertices of the bridge)
	std::list<VERTEX_TYPE> pocketVertices; 

	//length of pockets (sum of all individual vertices of pockets)
	double pocketLength; 
};
