#include "stdafx.h"
//#include "cgalinit.h"
#include ".\testobjectgenerator.h"

#include <CGAL/Polyhedron_incremental_builder_3.h>


// A modifier creating a triangle with the incremental builder.
template <class HDS>
class Build_triangle : public CGAL::Modifier_base<HDS> {
public:
    Build_triangle() {}
    void operator()( HDS& hds) {
        // Postcondition: `hds' is a valid polyhedral surface.
        CGAL::Polyhedron_incremental_builder_3<HDS> B( hds, true);
		/*
        B.begin_surface( 3, 1, 6);
        typedef typename HDS::Vertex   Vertex;
        typedef typename Vertex::Point Point;
        B.add_vertex( Point( 0, 0, 0));
        B.add_vertex( Point( 1, 0, 0));
        B.add_vertex( Point( 0, 1, 0));
        B.begin_facet();
        B.add_vertex_to_facet( 0);
        B.add_vertex_to_facet( 1);
        B.add_vertex_to_facet( 2);
        B.end_facet();
		B.end_surface();
		*/
		//B.begin_surface( 16, 14, 0);
		B.begin_surface( 8, 3, 0);
		
		typedef typename HDS::Vertex   Vertex;
		typedef typename Vertex::Point Point;

		B.add_vertex( Point( -2, -2, 0));
		B.add_vertex( Point( 2, -2, 0));
		B.add_vertex( Point( 2,  2, 0));
		B.add_vertex( Point( -2,  2, 0));

		B.begin_facet();
		B.add_vertex_to_facet( 0);
		B.add_vertex_to_facet( 1);
		B.add_vertex_to_facet( 2);
		B.add_vertex_to_facet( 3);
		B.end_facet();

		B.add_vertex( Point( -2, -2, 1));
		B.add_vertex( Point( 2, -2, 1));
		B.add_vertex( Point( 2,  2, 1));
		B.add_vertex( Point( -2,  2, 1));

		B.begin_facet();
		B.add_vertex_to_facet( 1);
		B.add_vertex_to_facet( 0);
		B.add_vertex_to_facet( 4);
		B.add_vertex_to_facet( 5);
		B.end_facet();
		
		B.begin_facet();
		B.add_vertex_to_facet( 2);
		B.add_vertex_to_facet( 1);
		B.add_vertex_to_facet( 5);
		B.add_vertex_to_facet( 6);
		B.end_facet();

		B.begin_facet();
		B.add_vertex_to_facet( 7);
		B.add_vertex_to_facet( 3);
		B.add_vertex_to_facet( 2);
		B.add_vertex_to_facet( 6);
		B.end_facet();

		B.begin_facet();
		B.add_vertex_to_facet( 0);
		B.add_vertex_to_facet( 3);
		B.add_vertex_to_facet( 7);
		B.add_vertex_to_facet( 4);
		B.end_facet();
	
		//begin top rectangular box
		B.add_vertex( Point( -1, -1, 1));
		B.add_vertex( Point( 1, -1, 1));
		B.add_vertex( Point( 1,  1, 1));
		B.add_vertex( Point( -1,  1, 1));

		B.add_vertex( Point( -1, -1, 2));
		B.add_vertex( Point( 1, -1, 2));
		B.add_vertex( Point( 1,  1, 2));
		B.add_vertex( Point( -1,  1, 2));

		B.begin_facet();
		B.add_vertex_to_facet( 5);
		B.add_vertex_to_facet( 4);
		B.add_vertex_to_facet( 8);
		B.add_vertex_to_facet( 9);
		B.end_facet();	

		B.begin_facet();
		B.add_vertex_to_facet( 5);
		B.add_vertex_to_facet( 9);
		B.add_vertex_to_facet( 10);
		B.add_vertex_to_facet( 6);
		B.end_facet();

		B.begin_facet();
		B.add_vertex_to_facet( 6);
		B.add_vertex_to_facet( 10);
		B.add_vertex_to_facet( 11);
		B.add_vertex_to_facet( 7);
		B.end_facet();
/*
		B.begin_facet();
		B.add_vertex_to_facet( 8);
		B.add_vertex_to_facet( 11);
		B.add_vertex_to_facet( 9);
		B.add_vertex_to_facet( 5);
		B.end_facet();
*/ 
		B.end_surface();
    }
};

TestObjectGenerator::TestObjectGenerator(void)
{
}

TestObjectGenerator::~TestObjectGenerator(void)
{
}

Polyhedron_3 * TestObjectGenerator::getTwoBigAndLittleBoxes(Polyhedron_3 * p)
{
	//Polyhedron_3 * p = new Polyhedron_3;
    Build_triangle<HalfedgeDS> triangle;
    p->delegate( triangle);
	return p; 
	/*
	CGAL::Polyhedron_incremental_builder_3<HalfedgeDS> B( hds, true);
	B.begin_surface( 16, 14, 0);
	typedef typename HalfedgeDS::Vertex   Vertex;
	typedef typename HalfedgeDS::Point Point;
	
	B.add_vertex( Point( -1.0, -1.0, 0));
	B.add_vertex( Point( 1.0, -1.0, 0.0));
	B.add_vertex( Point( 1.0,  1.0, 0.0));
	B.add_vertex( Point( -1.0,  1.0, 0.0));

	B.begin_facet();
	B.add_vertex_to_facet( 0);
	B.add_vertex_to_facet( 1);
	B.add_vertex_to_facet( 2);
	B.add_vertex_to_facet( 3);
	B.end_facet();

	B.add_vertex( Point( -1.0, -1.0, 0.5));
	B.add_vertex( Point( 1.0, -1.0, 0.5));
	B.add_vertex( Point( 1.0,  1.0, 0.5));
	B.add_vertex( Point( -1.0,  1.0, 0.5));
	
	B.begin_facet();
	B.add_vertex_to_facet( 0);
	B.add_vertex_to_facet( 1);
	B.add_vertex_to_facet( 5);
	B.add_vertex_to_facet( 4);
	B.end_facet();

	B.begin_facet();
	B.add_vertex_to_facet( 1);
	B.add_vertex_to_facet( 2);
	B.add_vertex_to_facet( 6);
	B.add_vertex_to_facet( 5);
	B.end_facet();

	B.begin_facet();
	B.add_vertex_to_facet( 2);
	B.add_vertex_to_facet( 3);
	B.add_vertex_to_facet( 7);
	B.add_vertex_to_facet( 6);
	B.end_facet();

	B.begin_facet();
	B.add_vertex_to_facet( 0);
	B.add_vertex_to_facet( 3);
	B.add_vertex_to_facet( 4);
	B.add_vertex_to_facet( 7);
	B.end_facet();

	B.end_surface();
	*/ 
	//return Polyhedron_3();
}
