#ifndef CGALINIT_H
#define CGALINIT_H

//#define USE_HOMOGENEOUS
#define USE_SIMPLE_CARTESIAN
/*
#ifdef USE_HOMOGENEOUS
#include <CGAL/Homogeneous.h>
#else
#include <CGAL/Cartesian.h>
#endif
*/

#ifdef USE_SIMPLE_CARTESIAN
#include <CGAL/Simple_cartesian.h>
#include <CGAL/Filtered_kernel.h>
#endif

//#include <CGAL/Simple_homogeneous.h>
#include <CGAL/Polyhedron_3.h>
#include <CGAL/Polyhedron_items_with_id_3.h>
#include <CGAL/point_generators_3.h>
#include <CGAL/copy_n.h>
#include <CGAL/Convex_hull_traits_3.h>
#include <CGAL/convex_hull_3.h>
#include <CGAL/bounding_box.h>

#include <vector>
#include <list>

//using std::list;
#ifdef CGAL_USE_GMP
#include <CGAL/Gmpz.h>
typedef CGAL::Gmpz RT;
#else
#include <CGAL/MP_Float.h>
typedef CGAL::MP_Float RT;
#endif

//typedef CGAL::Homogeneous<RT>                     K;
/*
#ifdef USE_HOMOGENEOUS
typedef CGAL::Homogeneous<double>					K;
#else
typedef CGAL::Cartesian<double>						K;
#endif
*/

#ifdef USE_SIMPLE_CARTESIAN
typedef CGAL::Simple_cartesian<double> SK;
typedef CGAL::Filtered_kernel<SK> FK;
struct K : public FK {};
#endif


typedef CGAL::Convex_hull_traits_3<K>             Traits;
//typedef Traits::Polyhedron_3                      Polyhedron_3;
typedef CGAL::Polyhedron_3<K,CGAL::Polyhedron_items_with_id_3>		Polyhedron_3; 
typedef K::Segment_3                              Segment_3;

// define point creator
typedef K::Point_3                                Point_3;
typedef K::Plane_3								  Plane_3;
typedef K::Vector_3								  Vector_3; 

//typedef CGAL::Creator_uniform_3<double, Point_3>  PointCreator;
typedef CGAL::Creator_uniform_3<int, Point_3>  PointCreator;
typedef Polyhedron_3::Vertex_iterator        Vertex_iterator;
typedef Polyhedron_3::Facet_iterator		 Facet_iterator; 
typedef Polyhedron_3::Edge_iterator		     Edge_iterator; 
typedef Polyhedron_3::Halfedge_iterator		 Halfedge_iterator;
typedef Polyhedron_3::Vertex					  Vertex;

typedef Polyhedron_3::Vertex_handle			 Vertex_handle;
typedef Polyhedron_3::Halfedge			     Halfedge;
typedef Polyhedron_3::Halfedge_handle		 Halfedge_handle;
typedef Polyhedron_3::HalfedgeDS             HalfedgeDS;
typedef Polyhedron_3::Halfedge_around_facet_circulator Halfedge_facet_circulator;
typedef Polyhedron_3::Halfedge_around_vertex_circulator Halfedge_around_vertex_circulator; 

#endif
